#include <gb/drawing.h>
#include <gb/gb.h>
#include <rand.h>
#include <stdio.h>
#include <gb/console.h>

#define DATA_IN_A (UBYTE *)0xA001U
#define DATA_IN_B (UBYTE *)0xA000U
#define SET_MIKRO (UBYTE *)0xA100U



// Variablen auf dem Stack sind statisch!
int i;
int j;
int koordcounter;
UBYTE data_a_old;
UBYTE data_a;
UBYTE data_b;
UBYTE data_b_old;
int richtung;

void clsg(){
	gotogxy(0, 0);
	for (i=0;i<18;i++)
		gprint("                    ");
}



void init_data(int* pointsa1, int* pointsa2, int* pointsb1, int* pointsb2,
			   int* pointsa1_old, int* pointsa2_old, int* pointsb1_old, int* pointsb2_old, int programm){

	
	// Debug:
	if(programm == 2){
		*DATA_IN_A = 0x40;
		*DATA_IN_B = 0x22;
		richtung = 1;
	}

	koordcounter = 0;

	for(i=0; i<70; i++){
		pointsa1[i] = 0;
		pointsa2[i] = 0;
		pointsb1[i] = 0;
		pointsb2[i] = 0;
		pointsa1_old[i] = 0;
		pointsa2_old[i] = 0;
		pointsb1_old[i] = 0;
		pointsb2_old[i] = 0;
	}
}


void copy_data(int* pointsa1, int* pointsa2, int* pointsb1, int* pointsb2,
			   int* pointsa1_old, int* pointsa2_old, int* pointsb1_old, int* pointsb2_old){
	for(i=0; i<70; i++){
		pointsa1_old[i] = pointsa1[i] ;
		pointsa2_old[i] = pointsa2[i] ;
		pointsb1_old[i] = pointsb1[i] ;
		pointsb2_old[i] = pointsb2[i] ;
	}
}


void read_data(int* pointsa1, int* pointsa2, int* pointsb1, int* pointsb2, int programm,
			unsigned* timediv){


	long bremse = (long) timediv * 10;
	int var, i;


	// Schleife zum einzelnen einlesen der Werte:
	// einlesen von adresse DATA_IN_A + B

	// auf positiven Nulldurchgang von Kanal A Triggern:
	if (programm == 1 || programm == 3) {
		// Faster Ausgabe:
		gotogxy(1, 17); // Buchstabe, Zeile
		gprintf("Triggering...");
		
		data_a = *DATA_IN_A;
		data_a_old = data_a;
		
		
		while(1){					
			data_a = *DATA_IN_A;
			gotogxy(14, 17); // Buchstabe, Zeile
		        gprintf("%x", data_a);
			
			// Trigger auf Nulldurchgang --> DATA = 0x80 ^= 128
			if(data_a >= 0x80 && data_a_old <= 0x80){
				break;
			}
			data_a_old = data_a;
		}
	}


	// Triggering lschen
	gotogxy(1, 17); // Buchstabe, Zeile
	gprintf("                   ");


	// Werte einlesen
	// Eingangswerte unsigned $0 bis $FF ^= 0-256
	// cast auf int -128 bis +128

        // langsam mode
        if (programm == 3 || programm == 4 || programm == 2){
          	for(i=0; i<70; i++){
          		data_a = *DATA_IN_A;
          		data_b = *DATA_IN_B;
		        pointsa1[i] = data_a - 128;
		        pointsb1[i] = data_b - 128;
		        // ausbremsen
		        //for(j=0; j<10000; j++) ;
		        // Ausgabe: 
		        gotogxy(4, 17); // Buchstabe, Zeile
			gprintf("In%d:", i);
			gotogxy(10, 17); // Buchstabe, Zeile
			gprintf("%x - %x", data_a, data_b);
				
			// debugging werte: 
			if (programm == 2){
				if (*DATA_IN_A <= 0x40)
					richtung = 1;
				else if (*DATA_IN_A >= 0xB0)
					richtung = -1;
				*DATA_IN_A += 1*richtung;
			}
	        }
	        for(i=0; i<70; i++){
	        	data_a = *DATA_IN_A;
          		data_b = *DATA_IN_B;
		        pointsa2[i] = data_a - 128;
		        pointsb2[i] = data_b - 128;
		        // ausbremsen
		        //for(j=0; j<10000; j++) ;
		        // Ausgabe: 
		        gotogxy(4, 17); // Buchstabe, Zeile
			gprintf("In%d:", i);
			gotogxy(10, 17); // Buchstabe, Zeile
			gprintf("%x - %x", data_a, data_b);
			
			// debugging werte: 
			if (programm == 2){
				if (*DATA_IN_A <= 0x40)
					richtung = 1;
				else if (*DATA_IN_A >= 0xB0)
					richtung = -1;
				*DATA_IN_A += 1*richtung;
			}
			
	        }
	// normal:        
        } else {
        	for(i=0; i<70; i++){
        	        data_a = *DATA_IN_A;
        		pointsa1[i] = data_a - 128;
        		// kanal b off
        		data_b = *DATA_IN_B;
        		pointsb1[i] = data_b - 128;
        	}
        	for(i=0; i<70; i++){
        	        data_a = *DATA_IN_A;
        		pointsa2[i] = data_a - 128;
        		// kanal b off
        		data_b = *DATA_IN_B;
        		pointsb2[i] = data_b - 128;
        	}
        }
}



void transform_data(int* pointsa1, int* pointsa2, int* pointsb1, int* pointsb2,
				    unsigned* cha_amp, unsigned* chb_amp, char* cha_mode, char* chb_mode){


	//color(LTGREY,WHITE,SOLID);
	//gotogxy(1, 17); // Buchstabe, Zeile
	//gprintf("b1_1: %d", pointsb1[0]/2);
	//gotogxy(11, 17); // Buchstabe, Zeile
	//gprintf("b2_1: %d", pointsb2[0]/2);


	if (*cha_mode == 'G'){
		for(i=0; i<70; i++){
			pointsa1[i] = 59;
			pointsa2[i] = 59;
		}
	} else {
		for(i=0; i<70; i++){

			// unskaliert: x ab 11, y ab +59 - y

			// skalieren auf:
			// Bereich : -57 bis +57
			// alle 14 Pixel ein DIV
			// Faktor: 0.4375

			pointsa1[i] /= 2;
			pointsa2[i] /= 2;

			pointsa1[i] = 59 - pointsa1[i];
			//if (pointsa1[i] < 3 || pointsa1[i] > 115)
			//	pointsa1[i] = 59; // aus dem Wertebereich -> Nullinie


			//gotogxy(1, 17); // Buchstabe, Zeile
			//gprintf("a%d: ", i);
			//gprintf("%d", pointsa1[i]);


			pointsa2[i] = 59 - pointsa2[i];
			//if (pointsa2[i] < 3 || pointsa2[i] > 115)
			//	pointsa2[i] = 59; // aus dem Wertebereich -> Nullinie
		}
	}

	if (*chb_mode == 'G'){
		for(i=0; i<70; i++){
			pointsb1[i] = 59;
			pointsb2[i] = 59;
		}
	} else {
		for(i=0; i<70; i++){

			// unskaliert: x ab 11, y ab +59 - y
			// Bereich : -57 bis +57

			pointsb1[i] /= 2;
		 	pointsb2[i] /= 2;


			pointsb1[i] = 59 - pointsb1[i];
			//if (pointsb1[i] < 3 || pointsb1[i] > 115)
			//	pointsb1[i] = 59; // aus dem Wertebereich -> Nullinie

			pointsb2[i] = 59 - pointsb2[i];
			//if (pointsb2[i] < 3 || pointsb2[i] > 115)
			//	pointsb2[i] = 59; // aus dem Wertebereich -> Nullinie


		}
	}
} // ende transform_data


void koordinaten(){
	int x, y;
	// gprintf("koordinaten");
	color(3,WHITE,SOLID); // Schwarz

	/* Koordinatenkreuz */
	line (10, 3, 150, 3); // x1, y1, x2, y2
	line (10, 115, 150, 115); // x1, y1, x2, y2
	line (10, 3, 10, 115);
	line (150, 3, 150, 115);

	/* Waagrecht-Zehner aufteilung */
	for (x=24;x<150;x=x+14)	{
		color(BLACK,WHITE,SOLID); // Schwarz
		plot_point(x,2);
		plot_point(x,116);
		color(LTGREY,WHITE,SOLID); // Grau
		line (x, 4, x, 114);
	}
	/* Senkrecht-8er aufteilung */
	for (y=17;y<115;y=y+14)	{
		color(3,WHITE,SOLID); // Schwarz
		plot_point(9,y);
		plot_point(151,y);
		color(1,WHITE,SOLID); // Grau
		line (11, y, 149, y);
	}
	//dunkelgraue mittellinie bei y=59
	color(DKGREY,WHITE,SOLID); // Grau
	line (11, 59, 149, 59);
}



void print_data(int* pointsa1, int* pointsa2, int* pointsb1, int* pointsb2,
			    int* pointsa1_old, int* pointsa2_old, int* pointsb1_old, int* pointsb2_old){

	// Kanal 1 zeichnen
	
	// koordinaten zeichnen
	if ((koordcounter++) == 10){
	        koordinaten();
		koordcounter = 0;
	}	

	for(i=0; i<70; i++){
		color(WHITE,WHITE,SOLID); // Weiss
		plot_point(11+i,pointsa1_old[i]); //x,y
		plot_point(11+i+70,pointsa2_old[i]); //x,y

		color(BLACK,WHITE,SOLID); // Schwarz
		plot_point(11+i,pointsa1[i]); //x,y
			//gotogxy(1, 17); // Buchstabe, Zeile
			//gprintf("a%d: ", i);
			//gprintf("%d", pointsa1[i]);

		plot_point(11+i+70,pointsa2[i]); //x,y
	}

	// Kanal 2 zeichnen
	for(i=0; i<70; i += 2){
		color(WHITE,WHITE,SOLID); // Weiss
		plot_point(11+i,pointsb1_old[i]); //x,y
		plot_point(11+i+70,pointsb2_old[i]); //x,y

		color(BLACK,WHITE,SOLID); // Schwarz
		plot_point(11+i,pointsb1[i]); //x,y
		plot_point(11+i+70,pointsb2[i]); //x,y
	}
	
}



void set_mikro(unsigned amp, char* mode, char channel) {

	// microcontroller die einstellwerte mitteilen.
	// 8Bit Code wird an die Stelle 0xA100U (externes RAM) geschrieben

	// debug:
		/*
		color(LTGREY,WHITE,SOLID);
		gotogxy(1, 17); // Buchstabe, Zeile
		gprintf("a: %u", amp);

		gotogxy(7, 17); // Buchstabe, Zeile
		gprintf("m: %c", *mode);

		gotogxy(12, 17); // Buchstabe, Zeile
		gprintf("c: %c", channel);
		*/

	// schreibzugriff ROM simulieren:

	int tmp = 0x00;

	if (channel == 'B')
		tmp += 0x20;

	if (*mode == 'D')
		tmp += 0x10;

	tmp += amp;

	*SET_MIKRO = tmp;

		color(LTGREY,WHITE,SOLID);
		gotogxy(1, 17); // Buchstabe, Zeile
		gprintf("Mikro: 0x%x", tmp);

}
